/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _DRAW_H_
#define _DRAW_H_

#include "doc.h"
#include "cursor.h"

void draw_line(doc *, int, int, int);
void draw_area(doc *, int, int, int, int);
void invalidate_all(doc *);
void invalidate_line(doc *, int);
void invalidate_line_and_next(doc *, int);
void invalidate_next(doc *);

void draw_cursor(cursor *);
void clear_cursor(cursor *);
void show_cursor(cursor *);
void show_chord(doc *, int, int);

void check_resize(doc *);

#endif /* _DRAW_H_ */
