/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -k1 -t -p -T -C -N keyword_lookup -g keywords.in  */
/*
 * l: a language for cgscore to describe actions
 * public domain, like cgscore
 */

#include "keywords.h"

#include <string.h>


#define TOTAL_KEYWORDS 11
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 8
#define MIN_HASH_VALUE 2
#define MAX_HASH_VALUE 19
/* maximum key range = 18, duplicates = 0 */

#ifdef __GNUC__
inline
#endif
static unsigned int
hash (str, len)
     register unsigned char *str;
     register int unsigned len;
{
  static const unsigned char asso_values[] =
    {
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20,  0, 20,  5,
      0,  0, 20, 20,  0,  0, 20, 20,  5, 20,
     20, 20, 20, 20, 10, 15, 20, 14, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 20,
    };
  return len + asso_values[str[0]];
}

#ifdef __GNUC__
inline
#endif
const struct keywords *
keyword_lookup (str, len)
     register unsigned char *str;
     register unsigned int len;
{
  static const struct keywords wordlist[] =
    {
      {"",}, {"",}, 
      {"do",  KEYWORD_DO},
      {"",}, 
      {"data",  KEYWORD_DATA},
      {"erase",  KEYWORD_ERASE},
      {"action",  KEYWORD_ACTION},
      {"include",  KEYWORD_INCLUDE},
      {"hinclude",  KEYWORD_HINCLUDE},
      {"load",  KEYWORD_LOAD},
      {"",}, {"",}, {"",}, 
      {"cinclude",  KEYWORD_CINCLUDE},
      {"redo",  KEYWORD_REDO},
      {"",}, {"",}, {"",}, 
      {"undo",  KEYWORD_UNDO},
      {"save",  KEYWORD_SAVE},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register const char *s = wordlist[key].name;

          if (*(unsigned char *)s == *str && !strcmp ((char *)str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

keyword lookup(char *s, int len)
{
  const struct keywords *ret = keyword_lookup(s, len);
  if (!ret) return NULL_KEYWORD;
  return ret->key;
}

static char *key[] = {
  "action",			 /* KEYWORD_ACTION */
  "cinclude",			 /* KEYWORD_CINCLUDE */
  "data",			 /* KEYWORD_DATA */
  "do",				 /* KEYWORD_DO */
  "erase",			 /* KEYWORD_ERASE */
  "hinclude",			 /* KEYWORD_HINCLUDE */
  "include",			 /* KEYWORD_INCLUDE */
  "load",			 /* KEYWORD_LOAD */
  "redo",			 /* KEYWORD_REDO */
  "save",			 /* KEYWORD_SAVE */
  "undo",			 /* KEYWORD_UNDO */
};

char *get_keyword(keyword x)
{
  return key[x];
}
