/*
 * l: a language for cgscore to describe actions
 * public domain, like cgscore
 */

#ifndef _KEYWORDS_H_
#define _KEYWORDS_H_

enum keyword {
  NULL_KEYWORD,
  KEYWORD_ACTION,
  KEYWORD_CINCLUDE,
  KEYWORD_DATA,
  KEYWORD_DO,
  KEYWORD_ERASE,
  KEYWORD_HINCLUDE,
  KEYWORD_INCLUDE,
  KEYWORD_LOAD,
  KEYWORD_REDO,
  KEYWORD_SAVE,
  KEYWORD_UNDO,
};

typedef enum keyword keyword;

struct keywords {
  char *name;
  keyword key;
};

keyword lookup(char *, int);
char *get_keyword(keyword);

#endif /* _KEYWORDS_H_ */
