#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 7 "grammar.y"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "keywords.h"
#include "files.h"
#include "string.h"
#include "list.h"
#include "actions.h"

#define LEXER_NORMAL	0
#define LEXER_F_ARGS	1
#define LEXER_INCLUDE	2
#define LEXER_CODE	3
#define LEXER_DATA	4

extern list include;
extern list cinclude;
extern list hinclude;
extern list actions;
extern list registered_actions;

static int lexer_mode = LEXER_NORMAL;
static int line = 0;

static char *buffer;
static int buffer_size;
static int buffer_maxsize;
static int put(int);
void end_parse(void);
static int yylex(void);
void yyerror(char *);

static int data;
static int _do;
static int undo;
static int redo;
static int save;
static int load;
static int erase;

#line 49 "y.tab.c"
#define INCLUDE 257
#define CINCLUDE 258
#define HINCLUDE 259
#define ACTION 260
#define DATA 261
#define DO 262
#define UNDO 263
#define REDO 264
#define SAVE 265
#define LOAD 266
#define F_ARGS 267
#define IDENTIFIER 268
#define CODE 269
#define ERASE 270
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    1,    1,    3,    3,    3,    2,    2,    7,    5,
    6,    6,    8,   11,   11,   12,   12,   12,   12,   12,
   12,   12,   15,   10,   16,    4,    9,   17,   14,   18,
   13,
};
short yylen[] = {                                         2,
    2,    0,    3,    2,    2,    2,    0,    2,    0,    5,
    2,    5,    1,    0,    2,    4,    4,    4,    4,    4,
    4,    4,    0,    2,    0,    2,    1,    0,    2,    0,
    2,
};
short yydefred[] = {                                      2,
    0,    0,    0,    0,   25,   25,   25,    3,    8,    0,
    4,    0,    5,    6,    0,    0,   26,   27,    0,   14,
   23,    0,    0,    0,    0,   10,    0,    0,    0,    0,
    0,    0,    0,   15,   12,   24,   30,   28,   28,   28,
   28,   28,   28,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   16,   31,   17,   29,   18,   19,   20,   21,
   22,
};
short yydgoto[] = {                                       1,
    2,    4,    8,   11,    9,   16,   10,   22,   19,   24,
   23,   34,   44,   46,   25,   12,   47,   45,
};
short yysindex[] = {                                      0,
    0,  -35, -248,    0,    0,    0,    0,    0,    0, -240,
    0, -236,    0,    0, -246, -100,    0,    0,  -16,    0,
    0,  -99, -258,  -14, -242,    0,  -95,  -94,  -93,  -92,
  -91,  -90,  -89,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -88, -234,  -87, -233,  -86,  -85,  -84,
  -83,  -82,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
short yyrindex[] = {                                      0,
    0,    1,    0,    2,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -79,    0,
    0,    0,  -80,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,   12,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -26,    0,    0,    0,    0,
};
#define YYTABLESIZE 262
short yytable[] = {                                       3,
    7,    1,   27,   28,   29,   30,   31,   32,    5,    6,
    7,   33,   48,   49,   50,   51,   52,   13,   14,   15,
   17,   18,   20,   21,   36,   26,   35,   37,   38,   39,
   40,   41,   42,   43,   54,   56,   53,   55,   57,   58,
   59,   60,   61,   11,   13,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    7,    9,
};
short yycheck[] = {                                      35,
    0,    0,  261,  262,  263,  264,  265,  266,  257,  258,
  259,  270,   39,   40,   41,   42,   43,    6,    7,  260,
  257,  268,  123,   40,  267,  125,   41,  123,  123,  123,
  123,  123,  123,  123,  269,  269,  125,  125,  125,  125,
  125,  125,  125,  123,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  260,  260,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 270
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'#'",0,0,0,0,"'('","')'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"INCLUDE",
"CINCLUDE","HINCLUDE","ACTION","DATA","DO","UNDO","REDO","SAVE","LOAD","F_ARGS",
"IDENTIFIER","CODE","ERASE",
};
char *yyrule[] = {
"$accept : file",
"file : includes actions",
"includes :",
"includes : includes '#' include",
"include : INCLUDE include_string",
"include : CINCLUDE include_string",
"include : HINCLUDE include_string",
"actions :",
"actions : actions action",
"$$1 :",
"action : $$1 action_declaration '{' action_body '}'",
"action_declaration : ACTION identifier",
"action_declaration : ACTION identifier '(' action_declaration_arguments ')'",
"action_body : action_items",
"action_items :",
"action_items : action_items action_item",
"action_item : DATA '{' data_arguments '}'",
"action_item : DO '{' ccode '}'",
"action_item : UNDO '{' ccode '}'",
"action_item : REDO '{' ccode '}'",
"action_item : SAVE '{' ccode '}'",
"action_item : LOAD '{' ccode '}'",
"action_item : ERASE '{' ccode '}'",
"$$2 :",
"action_declaration_arguments : $$2 F_ARGS",
"$$3 :",
"include_string : $$3 INCLUDE",
"identifier : IDENTIFIER",
"$$4 :",
"ccode : $$4 CODE",
"$$5 :",
"data_arguments : $$5 CODE",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 273 "grammar.y"

/* return 0 if ok, -1 if error */
int put(int c)
{
  if (buffer_size == buffer_maxsize) {
    char *nb;
    if (!buffer_size)
      nb = malloc(256);
    else
      nb = realloc(buffer, buffer_maxsize + 256);
    if (!nb) {
      fprintf(stderr, "out of memory\n");
      return -1;
    }
    buffer = nb;
    buffer_maxsize += 256;
  }
  buffer[buffer_size] = c;
  buffer_size++;
  return 0;
}

int get_byte(void)
{
  int c = get();
  if (c == EOF) return -1;
  if (c == '\n') line++;
  return c;
}

void unget_byte(int c)
{
  if (c == '\n') line--;
  unget(c);
}

/* -1 error, 0 no comment, 1 comment removed */
int check_comments(int c, int put_it)
{
  if (c != '/') return 0;
  c = get_byte();

  if (c == '*') {
    if (put_it) if (put('/') == -1 || put('*') == -1) return -1;
    while (1) {
      do {
        c = get_byte();
        if (c == -1) { yyerror("bad C comment"); return -1; }
        if (put_it) if (put(c) == -1) return -1;
      } while (c != '*');
      c = get_byte();
      if (c == '/') {
        if (put_it) if (put(c) == -1) return -1;
        return 1;
      }
      unget_byte(c);
    }
  }

  if (c == '/') {
    if (put_it) if (put('/') == -1 || put('/') == -1) return -1;
    while (1) {
      c = get_byte();
      if (put_it && c != -1) if (put(c) == -1) return -1;
      if (c == '\n') return 1;
      if (c == -1) { yyerror("bad C comment"); return -1; }
    }
  }

  unget_byte(c);
  return 0;
}

/* return 0 if ok, -1 if error */
int get_full_string(int sep)
{
  int c = get_byte();
  int last_escape = 0;

  if (c != sep) return -1;

  do {
    if (put(c) == -1) return -1;
    if (last_escape) last_escape = 0; else last_escape = (c == '\\');
    c = get_byte();
    if (c == -1) {
      yyerror("unterminated string sequence");
      return -1;
    }
  } while (c != sep || last_escape);

  if (put(sep) == -1) return -1;

  return 0;
}

static int get_code(int put_it)
{
  int depth = 0;
  if (put_it) if (put('{') == -1) return -1;
  while (1) {
    int c = get_byte();
    int comment;

    if (c == -1) {
      yyerror("bad C code");
      return -1;
    }

    comment = check_comments(c, 1);
    if (comment == -1) return -1;
    if (comment == 1) continue;

    if (c == '}' && depth == 0) {
      unget_byte(c);
      if (put_it) if (put('}') == -1) return -1;
      if (put(0) == -1) return -1;
      return CODE;
    }

    if (put(c) == -1) return -1;

    if (c == '{') depth++;
    if (c == '}') depth--;

    if (c == '"' || c == '\'') {
      buffer_size--;
      unget_byte(c);
      if (get_full_string(c) == -1)
        return -1;
    }
  }
}

int get_include(void)
{
  while (1) {
    int c = get_byte();
    if (c == -1 || c == '\n') {
      if (put(0) == -1) return -1;
      break;
    }
    if (put(c) == -1) return -1;
  }

  return INCLUDE;
}

int get_f_args(void)
{
  int c = get_byte();
  int depth = 0;

  while (c != ')' || depth) {
    int comment = check_comments(c, 0);
    if (comment == -1) return -1;

    if (!comment) if (put(c) == -1) return -1;
    if (c == '(') depth++;
    if (c == ')') depth--;
    if (c == '"' || c == '\'') {
      buffer_size--;
      unget_byte(c);
      if (get_full_string(c) == -1)
        return -1;
    }
    c = get_byte();
    if (c == -1) {
      yyerror("bad function arguments");
      return -1;
    }
  }

  if (put(0) == -1) return -1;

  unget_byte(')');

  return F_ARGS;
}

int yylex(void)
{
  int c;
  int comment;
  keyword k;

lex_more:
  buffer_size = 0;

  if (lexer_mode == LEXER_CODE)
    return get_code(1);

  if (lexer_mode == LEXER_DATA)
    return get_code(0);

  if (lexer_mode == LEXER_F_ARGS)
    return get_f_args();

  if (lexer_mode == LEXER_INCLUDE)
    return get_include();

  /* let's remove spaces */
  while (1) {
    c = get_byte();
    if (c == -1) return -1;
    if (!isspace(c))
      break;
  }

  /* keyword or identifier */
  if ((c >= 'a' && c <= 'z') ||
      (c >= 'A' && c <= 'Z') ||
      c == '_') {
    while (1) {
      if (put(c) == -1) return -1;
      c = get_byte();
      if ((c >= 'a' && c <= 'z') ||
          (c >= 'A' && c <= 'Z') ||
          (c >= '0' && c <= '9') ||
          c == '_')
        continue;
      unget_byte(c);
      if (put(0) == -1) return -1;
      switch ((k=lookup(buffer, buffer_size-1))) {
        case NULL_KEYWORD:
          return IDENTIFIER;
        case KEYWORD_INCLUDE:
          return INCLUDE;
        case KEYWORD_CINCLUDE:
          return CINCLUDE;
        case KEYWORD_HINCLUDE:
          return HINCLUDE;
        case KEYWORD_ACTION:
          return ACTION;
        case KEYWORD_DATA:
          return DATA;
        case KEYWORD_DO:
          return DO;
        case KEYWORD_UNDO:
          return UNDO;
        case KEYWORD_REDO:
          return REDO;
        case KEYWORD_SAVE:
          return SAVE;
        case KEYWORD_LOAD:
          return LOAD;
        case KEYWORD_ERASE:
          return ERASE;
      }
    }
  }

  /* comments */
  comment = check_comments(c, 0);
  if (comment == -1) return -1;
  if (comment == 1) goto lex_more;

  return c;
}

/* 0 ok, -1 error */
int parse_registered_actions(void)
{
  string s;
  int c;
  if (init_file("actions.list") == -1) return -1;
  /* get all registered actions */
  while (1) {
    /* remove spaces (return 0 if end of file (or error) reached) */
    do c = get(); while (isspace(c) && c != -1); if (c == -1) return 0;
    /* comment? */
    if (c == '#') {
      do c = get(); while (c != -1 && c != '\n'); if (c == -1) return -1;
      continue;
    }
    if (!isalpha(c) && c != '_') return -1;
    /* action name, get it full */
    buffer_size = 0;
    do {
      if (put(c) == -1) return -1;
      c = get();
    } while (isalnum(c) || c == '_');
    unget(c);
    if (c == -1) return -1;
    if (put(0) == -1) return -1;
    /* add it to the know actions */
    s = new_string(buffer);
    if (s == -1) return -1;
    if (list_add_int(registered_actions, (int)s) == -1 ||
        list_add_int(registered_actions, -1) == -1)
      return -1;
  }
  close_file();
  return 0;
}

void yyerror(char *s)
{
  fprintf(stderr, "%s:%d:%s\n", get_current_file(), line+1, s);
}

void end_parse(void)
{
  if (!buffer_maxsize) return;
  free(buffer);
  buffer_size = buffer_maxsize = 0;
  buffer = 0;
  lexer_mode = LEXER_NORMAL;
}

void reset_parse(void)
{
  lexer_mode = LEXER_NORMAL;
  line = 0;
}
#line 567 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 4:
#line 69 "grammar.y"
{
	    if (list_add_int(include, yyvsp[0]) == -1) YYERROR;
	  }
break;
case 5:
#line 73 "grammar.y"
{
	    if (list_add_int(cinclude, yyvsp[0]) == -1) YYERROR;
	  }
break;
case 6:
#line 77 "grammar.y"
{
	    if (list_add_int(hinclude, yyvsp[0]) == -1) YYERROR;
	  }
break;
case 9:
#line 88 "grammar.y"
{
	    data = -1;
	    _do = -1;
	    undo = -1;
	    redo = -1;
	    save = -1;
	    load = -1;
	    erase = -1;
	  }
break;
case 10:
#line 98 "grammar.y"
{
	    if (data == -1) {
	      yyerror("bad declaration: data missing");
	      YYERROR;
	    }
	    if (_do == -1) {
	      yyerror("bad declaration: do missing");
	      YYERROR;
	    }
	    if (undo == -1) {
	      yyerror("bad declaration: undo missing");
	      YYERROR;
	    }
	    if (redo == -1) {
	      yyerror("bad declaration: redo missing");
	      YYERROR;
	    }
	    if (save == -1) {
	      yyerror("bad declaration: save missing");
	      YYERROR;
	    }
	    if (load == -1) {
	      yyerror("bad declaration: load missing");
	      YYERROR;
	    }
	    if (erase == -1) {
	      yyerror("bad declaration: erase missing");
	      YYERROR;
	    }
	    if (list_add_int(actions, data) == -1 ||
	        list_add_int(actions, _do) == -1 ||
	        list_add_int(actions, undo) == -1 ||
	        list_add_int(actions, redo) == -1 ||
	        list_add_int(actions, save) == -1 ||
	        list_add_int(actions, load) == -1 ||
	        list_add_int(actions, erase) == -1) YYERROR;
	    if (register_action(list_size(actions)-9) == -1) YYERROR;
	  }
break;
case 11:
#line 140 "grammar.y"
{
	    if (list_add_int(actions, yyvsp[0]) == -1 ||
	        list_add_int(actions, -1) == -1) YYERROR;
	  }
break;
case 12:
#line 145 "grammar.y"
{
	    if (list_add_int(actions, yyvsp[-3]) == -1 ||
	        list_add_int(actions, yyvsp[-1]) == -1) YYERROR;
	  }
break;
case 16:
#line 162 "grammar.y"
{
	    if (data != -1) {
	      yyerror("data already defined");
	      YYERROR;
	    }
	    data = yyvsp[-1];
	  }
break;
case 17:
#line 170 "grammar.y"
{
	    if (_do != -1) {
	      yyerror("do already defined");
	      YYERROR;
	    }
	    _do = yyvsp[-1];
	  }
break;
case 18:
#line 178 "grammar.y"
{
	    if (undo != -1) {
	      yyerror("undo already defined");
	      YYERROR;
	    }
	    undo = yyvsp[-1];
	  }
break;
case 19:
#line 186 "grammar.y"
{
	    if (redo != -1) {
	      yyerror("redo already defined");
	      YYERROR;
	    }
	    redo = yyvsp[-1];
	  }
break;
case 20:
#line 194 "grammar.y"
{
	    if (save != -1) {
	      yyerror("save already defined");
	      YYERROR;
	    }
	    save = yyvsp[-1];
	  }
break;
case 21:
#line 202 "grammar.y"
{
	    if (load != -1) {
	      yyerror("load already defined");
	      YYERROR;
	    }
	    load = yyvsp[-1];
	  }
break;
case 22:
#line 210 "grammar.y"
{
	    if (erase != -1) {
	      yyerror("erase already defined");
	      YYERROR;
	    }
	    erase = yyvsp[-1];
	  }
break;
case 23:
#line 220 "grammar.y"
{ lexer_mode = LEXER_F_ARGS; }
break;
case 24:
#line 222 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    lexer_mode = LEXER_NORMAL;
	    yyval = s;
	  }
break;
case 25:
#line 231 "grammar.y"
{ lexer_mode = LEXER_INCLUDE; }
break;
case 26:
#line 233 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    lexer_mode = LEXER_NORMAL;
	    yyval = s;
	  }
break;
case 27:
#line 243 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    yyval = s;
	  }
break;
case 28:
#line 251 "grammar.y"
{ lexer_mode = LEXER_CODE; }
break;
case 29:
#line 253 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    lexer_mode = LEXER_NORMAL;
	    yyval = s;
	  }
break;
case 30:
#line 262 "grammar.y"
{ lexer_mode = LEXER_DATA; }
break;
case 31:
#line 264 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    lexer_mode = LEXER_NORMAL;
	    yyval = s;
	  }
break;
#line 922 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
