/*
 * l: a language for cgscore to describe actions
 * public domain, like cgscore
 */

#ifndef _DEBUG_H_
#define _DEBUG_H_

#define SLOW								\
  do {									\
    extern int printf(const char *, ...);				\
    static int did;							\
    if (!did) {								\
      printf("%s:%d:%s: rewrite, too slow\n",				\
             __FILE__, __LINE__, __FUNCTION__);				\
      did = 1;								\
    }									\
  } while (0)

#endif /* _DEBUG_H_ */
