/*
 * m: a language for cgscore to describe states
 * public domain, like cgscore
 */

#include "files.h"

#include <string.h>
#include <stdio.h>

static FILE *input_file;

static char *file_name;

/* -1 error, 0 ok */
int init_file(char *v)
{
  file_name = v;

  input_file = fopen(v, "r");
  if (!input_file) {
    perror(v);
    return -1;
  }

  return 0;
}

/* -1 error, 0 ok */
int close_file(void)
{
  if (fclose(input_file) == -1)
    return -1;
  return 0;
}

int get(void)
{
  return getc(input_file);
}

void unget(int c)
{
  ungetc(c, input_file);
}

char *get_current_file(void)
{
  return file_name;
}
