/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -k1 -t -p -T -C -N keyword_lookup -g keywords.in  */
/*
 * m: a language for cgscore to describe states
 * public domain, like cgscore
 */

#include "keywords.h"

#include <string.h>


#define TOTAL_KEYWORDS 8
#define MIN_WORD_LENGTH 4
#define MAX_WORD_LENGTH 8
#define MIN_HASH_VALUE 4
#define MAX_HASH_VALUE 13
/* maximum key range = 10, duplicates = 0 */

#ifdef __GNUC__
inline
#endif
static unsigned int
hash (str, len)
     register unsigned char *str;
     register int unsigned len;
{
  static const unsigned char asso_values[] =
    {
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14,  0, 14,  5,
      0,  5, 14, 14,  0,  0, 14, 14,  7, 14,
     14, 14, 14, 14, 14,  0, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14,
    };
  return len + asso_values[str[0]];
}

#ifdef __GNUC__
inline
#endif
const struct keywords *
keyword_lookup (str, len)
     register unsigned char *str;
     register unsigned int len;
{
  static const struct keywords wordlist[] =
    {
      {"",}, {"",}, {"",}, {"",}, 
      {"data",  KEYWORD_DATA},
      {"state",  KEYWORD_STATE},
      {"action",  KEYWORD_ACTION},
      {"include",  KEYWORD_INCLUDE},
      {"hinclude",  KEYWORD_HINCLUDE},
      {"",}, 
      {"enter",  KEYWORD_ENTER},
      {"",}, 
      {"leave",  KEYWORD_LEAVE},
      {"cinclude",  KEYWORD_CINCLUDE},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register const char *s = wordlist[key].name;

          if (*(unsigned char *)s == *str && !strcmp ((char *)str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

keyword lookup(char *s, int len)
{
  const struct keywords *ret = keyword_lookup(s, len);
  if (!ret) return NULL_KEYWORD;
  return ret->key;
}

static char *key[] = {
  "action",			/* KEYWORD_ACTION */
  "cinclude",			/* KEYWORD_CINCLUDE */
  "data",			/* KEYWORD_DATA */
  "enter",			/* KEYWORD_ENTER */
  "hinclude",			/* KEYWORD_HINCLUDE */
  "include",			/* KEYWORD_INCLUDE */
  "leave",			/* KEYWORD_LEAVE */
  "state",			/* KEYWORD_STATE */
};

char *get_keyword(keyword x)
{
  return key[x];
}
