/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _SIZE_H_
#define _SIZE_H_

#include "doc.h"

void size_delete_chord(doc *, int, int);
void size_change_chord(doc *, int, int);
void size_new_chord(doc *, int, int);
void size_prenew_line(doc *, int);
void size_new_line(doc *, int);
void size_presplit_line(doc *, int);
void size_split_line(doc *, int);
void size_premerge_line(doc *, int);
void size_merge_line(doc *, int);
void size_predelete_line(doc *, int);
void size_delete_line(doc *, int);
void size_set_text(doc *, int);
void size_reset(doc *);
void size_load(doc *);
void size_draw_lines(doc *, int, int);

void size_post_treatment(doc *);

void get_crossed_lines(doc *, int, int, int *, int *);
void get_crossed_chords(line *, int, int, int *, int *);

void update_horizontal_scrollbar(doc *);

void ensure_line_positioned(doc *, int);
void ensure_height_in_view(doc *, int);

void set_zoom(doc *, int);

#endif /* _SIZE_H_ */
