/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state about_state(cursor *c)
{
  data {
    struct about_gui g;
    cursor *c;
  }

  enter {
    data->c = c;
    init_about_gui(&data->g, this->thread);
    gtk_wrapper_widget_show_all(data->g.win);
    disable_cursor(c);
    greyall();
  }

  leave {
    ungreyall();
    gtk_wrapper_widget_destroy(data->g.win);
    enable_cursor(data->c);
  }

  action about_done {
    RETURN;
  }
}

state authors_state(cursor *c)
{
  data {
    struct authors_gui g;
    cursor *c;
  }

  enter {
    data->c = c;
    init_authors_gui(&data->g, this->thread);
    gtk_wrapper_widget_show_all(data->g.win);
    disable_cursor(c);
    greyall();
  }

  leave {
    ungreyall();
    gtk_wrapper_widget_destroy(data->g.win);
    enable_cursor(data->c);
  }

  action about_done {
    RETURN;
  }
}
