/* public domain stuff */

#include "sstring.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char *data;
static int size;
static int maxsize;

int new_string(char *s)
{
  int ret;
  int len = strlen(s)+1;
  if (size+len > maxsize) {
    int ns = maxsize + len + 2048;
    char *new;
    if (!data)
      new = malloc(ns);
    else
      new = realloc(data, ns);
    if (!new) return -1;
    data = new;
    maxsize = ns;
  }
  ret = size;
  memcpy(data+size, s, len);
  size += len;
  return ret;
}

char *
__attribute__((__no_instrument_function__))
get_string(int n)
{
  return data+n;
}
