/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _THREAD_H_
#define _THREAD_H_

#include "typedefs.h"

struct _m_state;

int thread_push(thread, struct _m_state *);
struct _m_state *thread_pop(thread);
struct _m_state *thread_top(thread);

thread new_thread(void);
void thread_delete(thread);

void thread_close(void);

/* return 0 if no top */
int thread_top_type(thread);

#endif /* _THREAD_H_ */
